<?
	
	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		$param=array('key'=>$argv[2]);
	}

	$PATH="../";
	include_once($PATH."include/include.php");
	include_once($PATH."include/admin.php");															/* Page Admin		*/

	include_once($PATH."include/limesurvey.php");

	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");		/* Entete HTML		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");	/* Entete HTML		*/

	$dbprf1=new ps_db;
	$dblim1=new ps_db;
    $dblim1->dbname($config["limesurveyhost"],"limesurvey",$config["limesurveypwd"],"limesurvey");
    
	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}	
	
	$q = "SELECT * FROM pia_limesurvey WHERE id=1";
	$dbprf1->query($q);
	if(!$dbprf1->next_record()) {
		AfficheLigne("ERREUR - Parametrage de synchronisation manquant");
		die();
	}

	$synchro_group 	= $dbprf1->f("synchro_group");
    $ldap_group 	= $dbprf1->f("ldap_group");
    $role_notchange = $dbprf1->f("role_notchange");

	if($synchro_group) {
		// Connexion LDAP
		$ds = ldap_connect($config['LDAPserver'], $config['LDAPport']);
		if (!$ds) {
			AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
			die();
		}
		
		$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
		if(!$r) {
			AfficheLigne("ERREUR - login impossible sur l'annuaire LDAP");
			die();
		}
	}

//==CREATION CLASSES===================================================================================================================================
	if($synchro_group) {
		AfficheLigne("");
		AfficheTitre("SYNCHRONISATION GROUPES");
	
		// Définition du fichier ou se trouve la liste des requêtes d'invitations
		$fic = "/var/www/html/limesurvey/application/config/ldap-invitations-posh-profil.php";

		// Supprimer le fichier fichier
		if(file_exists($fic)) unlink ($fic);

		// Ouvrir le fichier en écriture
		$fp = fopen ($fic, "w");
		if (!$fp) AfficheLigne("Erreur : impossible d'écrire le fichier '$fic'");
		else
		{
			fputs ($fp, "<?php\n\n");
			// Inscrire la liste des classes dans le fichier
			$res = ldap_search($ds,$config['LDAPracine'],$ldap_group );
			for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
			{
				
				// Nom de la classe
				$dn = ldap_get_dn($ds, $entryID);
				$lg = ldap_get_values($ds,$entryID,'cn');
				$cn = $lg[0];

				AfficheLigne("$cn : inscrite dans le fichiers des listes d'invitations");
				
				// Ecrire dans le fichier
				fputs ($fp, "\$ldap_queries[\$query_id]['ldapServerId'] = 0;\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['name'] = 'Membre de ".addslashes($cn)."';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['userbase'] = '" . $config["LDAPracine"] ."';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['userfilter'] = '(memberOf=".addslashes($dn).")';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['userscope'] = 'sub';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['firstname_attr'] = 'givenname';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['lastname_attr'] = 'sn';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['email_attr'] = 'mail';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['token_attr'] = '';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['language'] = '';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['attr1'] = '';\n");
				fputs ($fp, "\$ldap_queries[\$query_id]['attr2'] = '';\n");
				fputs ($fp, "\$query_id++;\n\n");
				
			}
			fputs ($fp, "?>");
			// Fermer le flux fichier
			fclose($fp);		
		}
    }		
    
    if($role_notchange==1) {
        // Pour chaque utilisateur non superadmin
        $dblim1->query("SELECT * FROM lime_users WHERE NOT EXISTS(SELECT * FROM lime_permissions WHERE lime_users.uid=lime_permissions.uid AND lime_permissions.entity='global' AND lime_permissions.permission='superadmin' AND lime_permissions.read_p=1)");
        while($dblim1->next_record()) {        
            $uid=$dblim1->f("uid");
            $dblim1->query("INSERT INTO lime_permissions (entity, entity_id, uid, permission, create_p, read_p, update_p, delete_p, import_p, export_p) VALUES ('global',0,$uid,'participantpanel',1,1,1,0,0,1) ON DUPLICATE KEY UPDATE create_p=1, read_p=1, update_p=1, delete_p=0, import_p=0, export_p=1");
            $dblim1->query("INSERT INTO lime_permissions (entity, entity_id, uid, permission, create_p, read_p, update_p, delete_p, import_p, export_p) VALUES ('global',0,$uid,'usergroups'      ,1,1,1,0,0,0) ON DUPLICATE KEY UPDATE create_p=1, read_p=1, update_p=1, delete_p=0, import_p=0, export_p=0");
            $dblim1->query("INSERT INTO lime_permissions (entity, entity_id, uid, permission, create_p, read_p, update_p, delete_p, import_p, export_p) VALUES ('global',0,$uid,'labelsets'       ,1,1,1,0,1,1) ON DUPLICATE KEY UPDATE create_p=1, read_p=1, update_p=1, delete_p=0, import_p=1, export_p=1");
            $dblim1->query("INSERT INTO lime_permissions (entity, entity_id, uid, permission, create_p, read_p, update_p, delete_p, import_p, export_p) VALUES ('global',0,$uid,'templates'       ,1,1,1,0,1,1) ON DUPLICATE KEY UPDATE create_p=1, read_p=1, update_p=1, delete_p=0, import_p=1, export_p=1");
            $dblim1->query("INSERT INTO lime_permissions (entity, entity_id, uid, permission, create_p, read_p, update_p, delete_p, import_p, export_p) VALUES ('global',0,$uid,'settings'        ,0,1,0,0,0,0) ON DUPLICATE KEY UPDATE create_p=0, read_p=1, update_p=0, delete_p=0, import_p=0, export_p=0");
            $dblim1->query("INSERT INTO lime_permissions (entity, entity_id, uid, permission, create_p, read_p, update_p, delete_p, import_p, export_p) VALUES ('global',0,$uid,'surveys'         ,1,0,0,0,0,1) ON DUPLICATE KEY UPDATE create_p=1, read_p=0, update_p=0, delete_p=0, import_p=0, export_p=1");
            $dblim1->query("INSERT INTO lime_permissions (entity, entity_id, uid, permission, create_p, read_p, update_p, delete_p, import_p, export_p) VALUES ('global',0,$uid,'users'           ,0,1,0,0,0,0) ON DUPLICATE KEY UPDATE create_p=0, read_p=1, update_p=0, delete_p=0, import_p=0, export_p=0");
            $dblim1->query("DELETE FROM lime_permissions WHERE lime_permissions.uid=$uid  AND lime_permissions.entity='global' AND lime_permissions.permission='auth_db'");
        }
    }


// Fin HTML
	if($_SESSION['user_login']!="UserCron") echo "</form>";
	if($_SESSION['user_login']!="UserCron") echo "</body>";
	if($_SESSION['user_login']!="UserCron") echo "</html>";
?>
