<?
	
	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		$param=array('key'=>$argv[2]);
	}

	$PATH="../";
	include_once($PATH."include/include.php");
	include_once($PATH."include/admin.php");															/* Page Admin		*/

	include_once($PATH."include/piwik.php");

	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");		/* Entete HTML		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");	/* Entete HTML		*/

    $dbprf1=new ps_db;
	$dbpiw1=new ps_db;
    $dbpiw1->dbname($config["piwikhost"],"piwik",$config["piwikpwd"],"piwik");

	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}	
	
	$q = "SELECT * FROM pia_piwik WHERE id=1";
	$dbprf1->query($q);
	if(!$dbprf1->next_record()) {
		AfficheLigne("ERREUR - Parametrage de synchronisation manquant");
		die();
	}

    $synchro_user 	= $dbprf1->f("synchro_user");
    $ldap_user      = $dbprf1->f("ldap_user");
    $ldap_view      = $dbprf1->f("ldap_view");
    $ldap_admin     = $dbprf1->f("ldap_admin");

	if($synchro_user) {
		// Connexion LDAP
		$ds = ldap_connect($config['LDAPserver'], $config['LDAPport']);
		if (!$ds) {
			AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
			die();
		}
		
		$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
		if(!$r) {
			AfficheLigne("ERREUR - login impossible sur l'annuaire LDAP");
			die();
		}
	}

//==CREATION CLASSES===================================================================================================================================
	if($synchro_user) {
		AfficheLigne("");
        AfficheTitre("SYNCHRONISATION UTILISATEUR");

		$res = ldap_search($ds,$config['LDAPracine'],$ldap_user);
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
            @$uid = ldap_get_values($ds,$entryID,'uid');
            @$mail= ldap_get_values($ds,$entryID,'mail');

            $dbpiw1->query("SELECT * FROM piwik_user WHERE login='".$uid[0]."'");
            if(!$dbpiw1->next_record()) {
                AfficheLigne("Création Utilisateur = ".$uid[0]);
                $dbpiw1->query("INSERT INTO piwik_user (login, alias, token_auth, email) VALUES ('".$uid[0]."','".$uid[0]."','".$uid[0]."','".$mail[0]."')");
            }
       	}	        

        if($ldap_view!="") {
            $dbpiw1->query("DELETE FROM piwik_access WHERE idsite=1 AND login!='admin' AND access='view'");

            $res = ldap_search($ds,$config['LDAPracine'],$ldap_view);
            for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
            {
                @$memberuid = ldap_get_values($ds,$entryID,'memberuid');
                foreach($memberuid as $key => $uid) {
                    if(is_int($key)) {
                        if($uid!="admin") {
                            $dbpiw1->query("SELECT * FROM piwik_access WHERE login='".$uid."' AND idsite=1");
                            if(!$dbpiw1->next_record()) {
                                AfficheLigne("Permission Lecture Utilisateur = ".$uid);
                                $dbpiw1->query("INSERT INTO piwik_access (login, idsite) VALUES ('$uid','1')");
                            }
                            $dbpiw1->query("UPDATE piwik_access SET access='view' WHERE login='$uid' AND idsite=1");
                        }
                    }
                }
            }	        
        }

        if($ldap_admin!="") {
            $dbpiw1->query("DELETE FROM piwik_access WHERE idsite=1 AND login!='admin' AND access='admin'");

            $res = ldap_search($ds,$config['LDAPracine'],$ldap_admin);
            for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
            {
                @$memberuid = ldap_get_values($ds,$entryID,'memberuid');
                foreach($memberuid as $key => $uid) {
                    if(is_int($key)) {
                        if($uid!="admin") {
                            $dbpiw1->query("SELECT * FROM piwik_access WHERE login='".$uid."' AND idsite=1");
                            if(!$dbpiw1->next_record()) {
                                AfficheLigne("Permission Admin Utilisateur = ".$uid);
                                $dbpiw1->query("INSERT INTO piwik_access (login, idsite) VALUES ('$uid','1')");
                            }
                            $dbpiw1->query("UPDATE piwik_access SET access='admin' WHERE login='$uid' AND idsite=1");
                        }
                    }
                }
            }	        
        }        
    }				


// Fin HTML
	if($_SESSION['user_login']!="UserCron") echo "</form>";
	if($_SESSION['user_login']!="UserCron") echo "</body>";
	if($_SESSION['user_login']!="UserCron") echo "</html>";
?>
