<?
	
	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		$param=array('key'=>$argv[2]);
	}

	$PATH="../";
	include_once($PATH."include/include.php");
	include_once($PATH."include/admin.php");															/* Page Admin		*/

	include_once($PATH."include/limesurvey.php");

	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");		/* Entete HTML		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");	/* Entete HTML		*/

	$dbprf1=new ps_db;

	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}	
	
	$q = "SELECT * FROM admin_limesurvey WHERE id=1";
	$dbprf1->query($q);
	if(!$dbprf1->next_record()) {
		AfficheLigne("ERREUR - Parametrage de synchronisation manquant");
		die();
	}

	$synchro_classe 	= $dbprf1->f("synchro_classe");
	$synchro_niveau 	= $dbprf1->f("synchro_niveau");
	$synchro_groupe 	= $dbprf1->f("synchro_groupe");
	$synchro_option 	= $dbprf1->f("synchro_option");

	// le type de recherche à éffectuer dans le ldap
	$types = array('Classe' => $synchro_classe, 'Niveau' => $synchro_niveau, 'Groupe' => $synchro_groupe, 'Option' => $synchro_option);

	if($synchro_classe || $synchro_niveau || $synchro_groupe || $synchro_option){
		// Connexion LDAP
		$ds = ldap_connect($config['LDAPserver'], $config['LDAPport']);
		if (!$ds) {
			AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
			die();
		}

		$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
		if(!$r) {
			AfficheLigne("ERREUR - login impossible sur l'annuaire LDAP");
			die();
		}

		// Définition du fichier ou se trouve la liste des requêtes d'invitations
		$fic = "/var/www/html/limesurvey/application/config/ldap-invitations-posh-profil.php";

		// Supprimer le fichier fichier
		if(file_exists($fic)) unlink ($fic);

		// Ouvrir le fichier en écriture
		$fp = fopen ($fic, "w");
		if (!$fp){
			AfficheLigne("Erreur : impossible d'écrire dans le fichier '$fic'");
			return;
		}

		fputs ($fp, "<?php\n\n");

		foreach($types as $key => $value){
			// Inscrire la liste des classes dans le fichier
			if($value > 0){
				AfficheLigne("");
				AfficheTitre("SYNCHRONISATION $key");
				$res = ldap_search($ds,$config['LDAPracine'], 'type='.$key);
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					// Nom de la classe, du niveau, du groupe ou de l'option
					$lg = ldap_get_values($ds,$entryID,'cn');
					$nom = $lg[0];

					AfficheLigne("$nom : inscrite dans le fichiers des listes d'invitations");

					// Ecrire dans le fichier
					fputs ($fp, "\$ldap_queries[\$query_id]['ldapServerId'] = 0;\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['name'] = '$key $nom';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['groupbase'] = '" . $config['LDAPracine'] ."';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['groupfilter'] = '(&(type=$key)(cn=$nom))';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['groupscope'] = 'sub';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['groupmemberattr'] = 'memberuid';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['groupmemberisdn'] = false;\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['useridattr'] = 'uid';\n");

					fputs ($fp, "\$ldap_queries[\$query_id]['userbase'] = '" . $config["LDAPracine"] ."';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['userfilter'] = '(objectclass=*)';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['userscope'] = 'sub';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['firstname_attr'] = 'givenname';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['lastname_attr'] = 'sn';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['email_attr'] = 'mail';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['token_attr'] = '';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['language'] = '';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['attr1'] = '';\n");
					fputs ($fp, "\$ldap_queries[\$query_id]['attr2'] = '';\n");
					fputs ($fp, "\$query_id++;\n\n");
				}
			}
		}
		fputs ($fp, "?>");
		// Fermer le flux fichier
		fclose($fp);
	}

	// Fin HTML
	if($_SESSION['user_login']!="UserCron") echo "</form>";
	if($_SESSION['user_login']!="UserCron") echo "</body>";
	if($_SESSION['user_login']!="UserCron") echo "</html>";
	?>
