<?
error_reporting(E_ALL & ~E_NOTICE);
$PATH="../";	
include_once($PATH."include/envole.php");
include_once($PATH."include/dbconf.php");
include_once($PATH."include/mysql.php");
include_once($PATH."include/synchronisation.php");
include_once($PATH."include/sacoche.php");

$db1=new ps_db;
$db1->dbname($config["sacochehost"],"sacoche",$config["sacochepwd"],"sacoche");

$db2=new ps_db;
$db2->dbname($config["sacochehost"],"sacoche",$config["sacochepwd"],"sacoche");


// On vérifie si le php est executé en ligne de commande
if(!is_null($argv)) {
	$_SESSION['user_login']="UserCron";
	set_time_limit(600000);
}

function search_array($array, $key, $value)
{
    $results = array();

    if (is_array($array)) {
        if (isset($array[$key]) && $array[$key] == $value) {
            $results[] = $array;
        }

        foreach ($array as $subarray) {
            $results = array_merge($results, search_array($subarray, $key, $value));
        }
    }

    return $results;
}

AfficheTitre("SUPPRESSION DES CORRESPONDANCES OBSOLETES");

$db1->query("SELECT * FROM sacoche_user WHERE user_id_ent!=''");
while($db1->next_record()) {
	$find=findUsersLDAP("uid",$db1->f("user_id_ent"));
	if(count($find)==0) {
		AfficheLigne("   - CORRESPONDANCE OBSOLETE = ".$db1->f("user_login")." / ".$db1->f("user_reference"));
		$db2->query("UPDATE sacoche_user SET user_id_ent='' WHERE user_login='".$db1->f("user_login")."'");
	}
}



AfficheTitre("LISTE DES ELEVES SACOCHE");
$eleves=listeUtilisateurs("Base","eleve");

$db1->query("SELECT * FROM sacoche_user WHERE user_profil_sigle='ELV'");
while($db1->next_record()) {
	
	// On regarde si l'utilisateur est déjà associé à un compte annuaire
	$fgtoattach=false;
	if($db1->f("user_id_ent")=="") $fgtoattach=true;

	if($db1->f("user_reference")=="") {
		AfficheLigneKO("   - LOGIN SACOCHE = ".$db1->f("user_login")." SANS INE");
	}
	else {
		if(!$fgtoattach) 
			AfficheLigneRAS("   - LOGIN SACOCHE = ".$db1->f("user_login")." - INE = ".$db1->f("user_reference")." déjà rattaché au login annuaire = ".$db1->f("user_id_ent"));
		else {
			// On recherche la correspondance de l'élève gepi via l'ine
			$find=search_array($eleves,"ine",$db1->f("user_reference"));
			if(count($find)==0) 
				AfficheLigneKO("   - LOGIN SACOCHE = ".$db1->f("user_login")." - INE = ".$db1->f("user_reference")." AUCUNE CORRESPONDANCE");	
			elseif(count($find)>1)
				AfficheLigneKO("   - LOGIN SACOCHE = ".$db1->f("user_login")." - INE = ".$db1->f("user_reference")." PLUSIEURS CORRESPONDANCES TROUVEES");	
			else {
				AfficheLigneOK("   - LOGIN SACOCHE = ".$db1->f("user_login")." - INE = ".$db1->f("user_reference")." rattachement au login annuaire ".$find[0]["uid"]);
				$db2->query("UPDATE sacoche_user SET user_id_ent='".$find[0]["uid"]."' WHERE user_login='".$db1->f("user_login")."'");
			}
		}
	}
}


AfficheTitre("LISTE DES RESPONSABLES SACOCHE");
$responsables=listeUtilisateurs("Base","responsable");
$ineresp=array();
foreach($responsables as $responsable) {
	$ineresp[$responsable["uid"]]=array();
	foreach($responsable["enfants"] as $enfant) {
		if($enfant["ine"]!="")
			array_push($ineresp[$responsable["uid"]],array("ine"=>$enfant["ine"],"uid"=>$responsable["uid"],"idprenomnom"=>$responsable["idprenomnom"]));
	}
}


$db1->query("SELECT * FROM sacoche_user WHERE user_profil_sigle='TUT'");
while($db1->next_record()) {
	// On regarde si l'utilisateur est déjà associé à un compte annuaire
	$fgtoattach=false;
	if($db1->f("user_id_ent")=="") $fgtoattach=true;

	if(!$fgtoattach)
	AfficheLigneRAS("   - LOGIN SACOCHE = ".$db1->f("user_login")." - USER_ID = ".$db1->f("user_id")." déjà rattaché au login annuaire = ".$db1->f("user_id_ent"));
	else {	
		// Pour chaque enfants du responsable
		$db2->query("SELECT * FROM sacoche_jointure_parent_eleve, sacoche_user WHERE sacoche_jointure_parent_eleve.parent_id='".$db1->f("user_id")."' AND sacoche_jointure_parent_eleve.eleve_id=sacoche_user.user_id");
		$fgfindattach=false;
		while($db2->next_record()) {
			// Recherche de son enfant dans l'annuaire via l'ine
			if($db2->f("user_reference")!="") {
				$find=search_array($ineresp,"ine",$db2->f("user_reference"));
				if(count($find)==1) {
					$fgfindattach=true;
					AfficheLigneOK("   - LOGIN SACOCHE = ".$db1->f("user_login")." - USER_ID = ".$db1->f("user_id")." rattachement au login annuaire ".$find[0]["uid"]);
					$db2->query("UPDATE sacoche_user SET user_id_ent='".$find[0]["uid"]."' WHERE user_login='".$db1->f("user_login")."'");
					break;
				}
				elseif(count($find)>1) {
					// Plusieurs parents pour l'enfant on recherche dans les parents de l'enfant trouvé celui qui se rapproche via prenomnom
					$find2=search_array($find,"idprenomnom",strtolower(replaceAccent($db1->f("user_prenom").$db1->f("user_nom"))));
					if(count($find2)==1) {
						$fgfindattach=true;
						AfficheLigneOK("   - LOGIN SACOCHE = ".$db1->f("user_login")." - USER_ID = ".$db1->f("user_id")." rattachement au login annuaire ".$find2[0]["uid"]);
						$db2->query("UPDATE sacoche_user SET user_id_ent='".$find2[0]["uid"]."' WHERE user_login='".$db1->f("user_login")."'");
						break;
					}
				}
			}
		}

		if(!$fgfindattach) {
			AfficheLigneKO("   - LOGIN SACOCHE = ".$db1->f("user_login")." - USER_ID = ".$db1->f("user_id")." rapprochement non trouvé");
		}
	}
}


AfficheTitre("LISTE DES PERSONNELS SACOCHE");
$personnels=array_merge(listeUtilisateurs("Base","enseignant"),listeUtilisateurs("Base","administratif"));


$db1->query("SELECT * FROM sacoche_user WHERE user_profil_sigle='ENS' OR user_profil_sigle='DIR' OR user_profil_sigle='DOC' OR user_profil_sigle='EDU'");
while($db1->next_record()) {
	// On regarde si l'utilisateur est déjà associé à un compte annuaire
	$fgtoattach=false;
	if($db1->f("user_id_ent")=="") $fgtoattach=true;

	if(!$fgtoattach)
		AfficheLigneRAS("   - LOGIN SACOCHE = ".$db1->f("user_login")." - USER_ID = ".$db1->f("user_id")." déjà rattaché au login annuaire = ".$db1->f("user_id_ent"));
	else {	

		$find=search_array($personnels,"idprenomnom",strtolower(replaceAccent($db1->f("user_prenom").$db1->f("user_nom"))));
		if(count($find)==1) {
			AfficheLigneOK("   - LOGIN SACOCHE = ".$db1->f("user_login")." USER_ID = ".$db1->f("user_id")." rattachement au login annuaire ".$find[0]["uid"]);
			$db2->query("UPDATE sacoche_user SET user_id_ent='".$find[0]["uid"]."' WHERE user_login='".$db1->f("user_login")."'");
		}
		else 
			AfficheLigneKO("   - LOGIN SACOCHE = ".$db1->f("user_login")." USER_ID = ".$db1->f("user_id")." rapprochement non trouvé");
	}
}

AfficheTitre("RATTACHEMENT DU COMPTE ADMIN");
$db2->query("UPDATE sacoche_user SET user_id_ent='admin' WHERE user_login='admin'");
if($config["uid_addadmin"]!="") $db2->query("UPDATE sacoche_user SET user_id_ent='".$config["uid_addadmin"]."' WHERE user_login='".$config["uid_addadmin"]."'");


AfficheLigne("");
AfficheLigne("");
AfficheLigne("");
	
