<?
	$_SERVER['REQUEST_URI']="/wordpress";
	$PATH="../";	
	include_once($PATH."include/envole.php");
	include_once($PATH."include/dbconf.php");
	include_once($PATH."include/mysql.php");
	$db1=new ps_db;
	$db2=new ps_db;
    $db1->dbname($config["dbhost"],"poshprofile",$config["dbpassword"],"poshprofile");
    $db2->dbname($config["dbhost"],"poshprofile",$config["dbpassword"],"poshprofile");

	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		$param=array('key'=>$argv[2]);
		//$_SERVER[ 'HTTP_HOST' ] = "amonecole23.ac-arno.fr";
		$_SERVER[ 'HTTP_HOST' ] = $config['host']; // Orléans
	}
	
	// Include général de wordpress
	include_once('../../wordpress/wp-load.php');
	require_wp_db();	
	include_once('../../wordpress/wp-admin/includes/user.php');
    include_once('../../wordpress/wp-admin/includes/plugin.php' );
    
	// Permet d'ignorer les erreurs wordpress dans le cas plusieurs utilisateurs auraient le meme email
	define('WP_IMPORTING', true);

	// Include minimum pour posh-profil
	include_once($PATH."include/admin.php");
	include_once($PATH."include/session.php");
	if($_SESSION['user_login']=="") $_SESSION['user_login']="UserCron";
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");
	
	global $wpdb;
	set_time_limit(60000);
	
//==FUNCTION===========================================================================================================================================
	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}
	
	function AfficheContinue($label) {
		echo $label;
	 }

	// Liste des sites
	function my_get_blog_list( $start = 0, $num = 10, $deprecated = '' ) {
		_deprecated_function( __FUNCTION__, '3.0' );

		global $wpdb;
		$blogs = $wpdb->get_results( $wpdb->prepare("SELECT blog_id, domain, path FROM $wpdb->blogs WHERE site_id = %d AND archived = '0' AND mature = '0' AND spam = '0' AND deleted = '0' ORDER BY registered DESC", $wpdb->siteid), ARRAY_A );
		
		foreach ( (array) $blogs as $details ) {
			$blog_list[ $details['blog_id'] ] = $details;
			$blog_list[ $details['blog_id'] ]['postcount'] = $wpdb->get_var( "SELECT COUNT(ID) FROM " . $wpdb->get_blog_prefix( $details['blog_id'] ). "posts WHERE post_status='publish' AND post_type='post'" );
		}
		unset( $blogs );
		$blogs = $blog_list;

		if ( false == is_array( $blogs ) )
			return array();

		if ( $num == 'all' )
			return array_slice( $blogs, $start, count( $blogs ) );
		else
			return array_slice( $blogs, $start, $num );
	}	

    function GenerateUserByMember($id,$ds,$memberuid,$role,$role_notchange) {
        if(is_array($memberuid)) {
            foreach($memberuid as $key => $value) {
                if(is_int($key)) {
                    $ldapsearch="(uid=".$value.")";
                    $res = ldap_search($ds,$config['LDAPracine'],str_replace("#login#",$user_info->user_login,$ldapsearch));
				    for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				    {
					    GenerateUser($id,$ds,$entryID,$role,$role_notchange);	
				    }
                }
            }
        }
        // sinon m'a qu'un seul uid
        else {
            $ldapsearch="(uid=".$memberuid.")";
            $res = ldap_search($ds,$config['LDAPracine'],str_replace("#login#",$user_info->user_login,$ldapsearch));
            for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
            {
                GenerateUser($id,$ds,$entryID,$role,$role_notchange);	
            }
        }      
    }

	// Création / Modification des user
	function GenerateUser($id,$ds,$entryID,$role,$role_notchange) {
		$uid		= ldap_get_values($ds,$entryID,'uid');
		$cn			= ldap_get_values($ds,$entryID,'cn');
		$mail		= ldap_get_values($ds,$entryID,'mail');
								
		// Création de l'utilisateur
		// la fonction  get_userdatabylogin est dans /var/www/html/wordpress/wp-includes/pluggable.php
		// s'il n'est pas dans la bd wordpress wp_users il est créé.
		if (!$user=get_userdatabylogin($uid[0])){
			$user_id = wp_create_user($uid[0], $pass[0], $mail[0]);	
		}
		else{
			$user_id=$user->ID;
		}
		
		// Modification de l'utilisateur
		// s'il est  dans la bd wordpress wp_users il est mis ajour.
		wp_update_user(array ('ID' => $user_id, 'user_email' => $mail[0]));
		
		if(is_user_member_of_blog( $user_id, $id ) AND !($role_notchange)){
			AfficheLigne("Utilisateur = $uid[0] = Ne pas modifier");
		}	
		else {
			AfficheLigne("Utilisateur = $uid[0] > $role");
			add_user_to_blog( $id, $user_id, $role);
		}
	}

	// rattachement d'un utilisateur à groupe wp-sentry d'un site
	function AtacheUserSentry($id,$groupe,$user_id) {
		global $wpdb;
		
	    // plugin groupe wp-sentry
        if($groupe!=""){
            // construire le nom de la table wp_sentry associée au blog
            $blog_tb="wp_";
            if($id > 1) $blog_tb="wp_".$id."_";
			
            // recherche du groupe wp_sentry associé
	        $group = $wpdb->get_row("SELECT * FROM ".$blog_tb."sentry_groups WHERE name=\"".$groupe."\"");
            $gid=$group->id;
			
            // si le groupe n'existe pas, on le génère
            if($gid=="") {
                $sql="INSERT INTO ".$blog_tb."sentry_groups(name) VALUES(\"".$groupe."\")";
                $wpdb->query($sql);
				
                $group = $wpdb->get_row("SELECT * FROM ".$blog_tb."sentry_groups WHERE name=\"".$groupe."\"");
                $gid=$group->id;
            }

            // On affecte la personne au groupe wp_sentry
			if ($group->member_list!="") $group_members = explode(',', $group->member_list); 
			else $group_members = array();
		  
			if(!in_array($user_id, $group_members)) array_push($group_members,$user_id);
			$group->member_list=implode(',',$group_members);

			$sql="UPDATE ".$blog_tb."sentry_groups SET member_list=\"".$group->member_list."\" WHERE id=$gid";
			$wpdb->query($sql);	        
	    }				    
	}
	
	
	// Liste des groupes
	function ListeGroupSentry($id) {
		global $wpdb;
		
		// construire le nom de la table wp_sentry associée au blog
		$blog_tb="wp_";
		if($id > 1) $blog_tb="wp_".$id."_";
		
		$groups = $wpdb->get_results("SELECT * FROM ".$blog_tb."sentry_groups");
		
		return $groups;
	}
	
	// detachement d'un utilisateur au groupe wp-sentry
	function DetacheUserSentry($id,$userid) {
		global $wpdb;
		
		// construire le nom de la table wp_sentry associée au blog
		$blog_tb="wp_";
		if($id > 1) $blog_tb="wp_".$id."_";
		
		$groups = $wpdb->get_results("SELECT * FROM ".$blog_tb."sentry_groups");
		foreach($groups as $group) {
			if ($group->member_list!="") {
				$gid=$group->id;
				$group_members = explode(',', $group->member_list); 
				
				if(in_array($userid,$group_members)) {
					$key = array_search($userid, $group_members);
				
					unset($group_members[$key]);
					$group->member_list=implode(',',$group_members);
					$sql="UPDATE ".$blog_tb."sentry_groups SET member_list='".$group->member_list."' WHERE id=$gid";
					$wpdb->query($sql);				
				}
			}
		}
	}
		
	// detachement des utilisateurs à un site
	function DetacheUserBlog($id,$ds,$ldapsearch) {	
		global $config;

		$user=get_userdatabylogin('admin');
		$admin_id=$user->ID;
							
		$ldapsearch=str_replace("()","",$ldapsearch);
				
		
		// Pour chaque utilisateur du blog on vérifie que l'utilisateur existe toujours
		$blogusers=get_users("blog_id=$id");
		foreach ($blogusers as $user) {
							
			// Ne jamais enlever admin
			if($user->user_login=="admin") {
				AfficheLigne("Utilisateur = ".$user->user_login." = existe toujours");
			}
			else {
				// S'il n'existe pas on le supprime et on attache ses articles à l'utilisateur admin
				$res = ldap_search($ds,$config['LDAPracine'],str_replace("#login#",$user->user_login,$ldapsearch));
				if($entryID=ldap_first_entry($ds,$res))
					AfficheLigne("Utilisateur = ".$user->user_login." = existe toujours");
				else {
					$user_id=$user->ID;
					AfficheLigne("Utilisateur = ".$user->user_login." = supprimé");;
					
					// Détacher l'utilisateur du site
					remove_user_from_blog($user_id,$id,$admin_id);	
					DetacheUserSentry($id,$user_id);	
				}
			}
		}
	}

	
//== BUDDYPRESS ====================================================================================================

	// Lister les groupe BUDDY d'un blog
	function listGroupeBuddy($id) {
		global $wpdb;

        // Liste des groupes buddy d'un blog
        $tbbuddy=array();
		$buddys = $wpdb->get_results("SELECT * FROM wp_bp_groups");
		foreach ( (array) $buddys as $buddy ) {
			array_push($tbbuddy, $buddy->id);
		}


		return $tbbuddy;
	}

	// Associer Admin au groupe Buddypress
	function creerAdminBuddyPress ($idGrp, $groupe, $idAdmin, $nomAdmin) {
		global $wpdb;
		global $config;


		// On va vérifier qu'il n'est pas déjà membre
		$lireMembers = $wpdb->get_row("SELECT id FROM wp_bp_groups_members WHERE user_id='$idAdmin' and group_id='$idGrp'");
		if ($lireMembers->id=="") {
			AfficheLigne("Rattachement Utilisateur = ".$nomAdmin);

			// Ajout à la table des membres du groupe
			$wpdb->query("INSERT INTO wp_bp_groups_members (group_id, user_id, inviter_id, is_admin, is_mod, user_title, date_modified, comments, is_confirmed, is_banned, invite_sent) VALUES ('" . addslashes($idGrp) . "', '" . $idAdmin ."', '0', '1', '0', 'Administration', NOW(), '', '1', '0', '0')");
			
			// Mise à jour de la table wp_bp_activity pour les admin
			/*
			if ($nomAdmin=="admin") $wpdb->query("INSERT INTO `wp_bp_activity` (`user_id`, `component`, `type`, `action`, `content`, `primary_link`, `item_id`, `secondary_item_id`, `date_recorded`, `hide_sitewide`, `mptt_left`, `mptt_right`, `is_spam`) VALUES (" . $idAdmin .", 'groups', 'created_group', '<a href=\"https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomAdmin) . "/\" title=\"" . addslashes($nomAdmin) . "\">" . addslashes($nomAdmin) . "</a> a créé le groupe <a href=\"https://" . $config['host'] ."/wordpress/groupes/" . $groupe . "/\">" . $groupe . "</a>', '', 'https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomAdmin) . "/', " . $idGrp . ", 0, NOW(), 1, 0, 0, 0)");
			else $wpdb->query("INSERT INTO `wp_bp_activity` (`user_id`, `component`, `type`, `action`, `content`, `primary_link`, `item_id`, `secondary_item_id`, `date_recorded`, `hide_sitewide`, `mptt_left`, `mptt_right`, `is_spam`) VALUES (" . $idAdmin .", 'groups', 'joined_group', '<a href=\"https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomAdmin) . "/\" title=\"" . addslashes($nomAdmin) . "\">" . addslashes($nomAdmin) . "</a> a rejoint le groupe <a href=\"https://" . $config['host'] ."/wordpress/groupes/" . $groupe . "/\">" . $groupe . "</a>', '', 'https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomAdmin) . "/', " . $idGrp . ", 0, NOW(), 1, 0, 0, 0)");
			*/

			// Mise à jour des métas données #1
			$r = $wpdb->get_row("SELECT id FROM wp_bp_groups_groupmeta WHERE group_id='$idGrp' AND meta_key='total_member_count'");
			if ($r->id=="") $wpdb->query("INSERT INTO wp_bp_groups_groupmeta (group_id, meta_key, meta_value) VALUES ('" . addslashes($idGrp) . "', 'total_member_count', '1')"); 
			else $wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=meta_value+1 WHERE group_id='$idGrp' AND meta_key='total_member_count'"); 
			
			// Mise à jour des métas données #2
			$r = $wpdb->get_row("SELECT id FROM wp_bp_groups_groupmeta WHERE group_id='$idGrp' AND meta_key='last_activity'");
			if ($r->id=="") $wpdb->query("INSERT INTO wp_bp_groups_groupmeta (group_id, meta_key, meta_value) VALUES ('" . addslashes($idGrp) . "', 'last_activity', NOW())"); 
			else $wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=NOW() WHERE group_id='$idGrp' AND meta_key='last_activity'"); 
			
			// Mise à jour nombre de groupes par utilisateur dans wp_usermeta 
			$meta = $wpdb->get_row("SELECT umeta_id FROM wp_usermeta WHERE user_id='" . $idAdmin ."' AND meta_key='total_group_count'");
			$idMeta = $meta->umeta_id; 
			if ($idMeta!="") $wpdb->query("UPDATE wp_usermeta SET meta_value=meta_value+1 WHERE umeta_id='" . $idMeta . "'");
			else $wpdb->query("INSERT INTO wp_usermeta (user_id, meta_key, meta_value) VALUES (" . $idAdmin .", 'total_group_count', '1')");
		}
		else {
			AfficheLigne("Utilisateur déjà rattaché = ".$nomAdmin);
		}
	}

	// Creation d'un Groupe BUDDY dans un blog
	function createGroupeBuddy($id,$groupe) {
		global $wpdb;
		global $config;
		global $idadmin1;
		global $idadmin2;

		// Si le groupe n'existe pas, on le génère
		$group = $wpdb->get_row("SELECT * FROM wp_bp_groups WHERE name='" . addslashes($groupe) . "'");
		if ($group->id=="") {
			AfficheLigne("Groupe Création = ".$groupe);
			$wpdb->query("INSERT INTO wp_bp_groups (creator_id, name, slug, description, status, enable_forum, date_created, parent_id) VALUES ('1', '" . addslashes($groupe) . "', '" . addslashes($groupe) . "', '" . addslashes($groupe) . "', 'private', 0, NOW(), 0)");
		}
		else AfficheLigne("Groupe Existe = ".$groupe);
		
		// Recherche de l'id du groupe buddypress créé ou existant
		$group = $wpdb->get_row("SELECT id FROM wp_bp_groups WHERE name='" . addslashes($groupe) . "'");
		$gid = $group->id;

		if($gid!="") {
			// Mise à jour métadonnées du groupe si elle n'existe pas (cas d'un groupe fraichement créé)
			$r = $wpdb->get_row("SELECT id FROM wp_bp_groups_groupmeta WHERE group_id='$gid' AND meta_key='invite_status'");
			if ($r->id=="") $wpdb->query("INSERT INTO wp_bp_groups_groupmeta (group_id, meta_key, meta_value) VALUES ('" . addslashes($gid) . "', 'invite_status', 'admins')");

			// Forcer le rattachement des Admin
			creerAdminBuddyPress ($gid, $groupe, $idadmin1, "admin");
			if($idadmin2!="") creerAdminBuddyPress ($gid, $groupe, $idadmin2, $config['uid_addadmin']);
		}
		return $gid;
	}

	// Suppression d'un Groupe BUDDY dans un blog
	function deleteGroupeBuddy($id,$idbuddy) {
		global $wpdb;

        // Recherche du groupe wp_sentry associé
		$group = $wpdb->get_row("SELECT * FROM wp_bp_groups WHERE id=\"".$idbuddy."\"");
		$name=$group->name;        		

		// Suppression
		AfficheLigne("Suppression Groupe = ".$name);
		$wpdb->query("DELETE FROM wp_bp_groups WHERE id=$idbuddy");
		$wpdb->query("DELETE FROM wp_bp_groups_groupmeta WHERE group_id=$idbuddy");
		$wpdb->query("DELETE FROM wp_bp_groups_members WHERE group_id=$idbuddy");
	}

	// Liste des membres d'un groupe BUDDY
	function memberBuddy($id,$gid) {
		global $wpdb;

		$group_members=array();
		$groups = $wpdb->get_results("SELECT * FROM wp_bp_groups_members WHERE group_id='$gid'");
		foreach($groups as $group) {
			array_push($group_members,$group->user_id);
		}

		return $group_members;
	}

	// Rattachement d'un utilisateur à un Groupe BUDDY
	function attacheUserBuddy($id,$gid,$groupe,$uid) {
		global $wpdb;
		global $idadmin1;
		global $idadmin2;


		if ($user=get_userdatabylogin($uid)) {
			$user_id=$user->ID;

			// Les Admin sont déjà rattaché on passe
			if($user_id==$idadmin1||$user_id==$idadmin2) return;

			// Vérifions si le membre n'est pas déjà enregistré
			$lireMembers = $wpdb->get_row("SELECT id FROM wp_bp_groups_members WHERE user_id='$user_id' and group_id='$gid'");
			if ($lireMembers->id!="")
				AfficheLigne("Utilisateur déjà rattaché = ".$uid);
			else {
				AfficheLigne("Rattachement Utilisateur = ".$uid);
				
				// Ajout à la table des membres du groupe
				$wpdb->query("INSERT INTO wp_bp_groups_members (group_id, user_id, inviter_id, is_admin, is_mod, user_title, date_modified, comments, is_confirmed, is_banned, invite_sent) VALUES ('" . addslashes($gid) . "', '" . $user_id ."', '0', '0', '0', '', NOW(), '', '1', '0', '0')");
				

				// Mise à jour de la table wp_bp_activity pour l'utilisateur
				/*
				$wpdb->query("INSERT INTO `wp_bp_activity` (`user_id`, `component`, `type`, `action`, `content`, `primary_link`, `item_id`, `secondary_item_id`, `date_recorded`, `hide_sitewide`, `mptt_left`, `mptt_right`, `is_spam`) VALUES (" . $user_id .", 'groups', 'joined_group', '<a href=\"https://" . $config['host'] ."/wordpress/membres/" . addslashes($uid) . "/\" title=\"" . addslashes($uid) . "\">" . addslashes($uid) . "</a> a rejoint le groupe <a href=\"https://" . $config['host'] ."/wordpress/groupes/" . $groupe . "/\">" . $groupe . "</a>', '', 'https://" . $config['host'] ."/wordpress/membres/" . addslashes($uid) . "/', " . $gid . ", 0, NOW(), 1, 0, 0, 0)");
				*/
				
				// Mise à jour du nombre d'utilsateurs dans le groupe
				$wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=meta_value+1 WHERE group_id='$gid' AND meta_key='total_member_count'"); 
				$wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=NOW() WHERE group_id='$gid' AND meta_key='last_activity'"); 
				
				// Mise à jour nombre de groupes par utilisateursdans wp_usermeta (nombre de groupe de l'utilisateur)
				$meta = $wpdb->get_row("SELECT umeta_id FROM wp_usermeta WHERE user_id='" . $user_id ."' AND meta_key='total_group_count'");
				$idMeta = $meta->umeta_id; 
				if ($idMeta!="") $wpdb->query("UPDATE wp_usermeta SET meta_value=meta_value+1 WHERE umeta_id='" . $idMeta . "'");
				else $wpdb->query("INSERT INTO wp_usermeta (user_id, meta_key, meta_value) VALUES (" . $user_id .", 'total_group_count', '1')");
				$wpdb->query("UPDATE wp_usermeta SET meta_value=NOW() WHERE user_id='$userId' AND meta_key='last_activity'"); 
			}				
		}
	}

	// Détachement d'un utilisateur d'un groupe BUDDY
	function detacheUserBuddy($id,$gid,$userid) {
		global $wpdb;

		$lireMembers = $wpdb->get_row("SELECT * FROM wp_bp_groups_members WHERE group_id=$gid AND user_id='$userid'");
		if ($lireMembers->id!="") {
			// Suppression de la table des membres de l'utilisateur
			$wpdb->query("DELETE FROM wp_bp_groups_members WHERE group_id='" . $gid . "' AND user_id='$userid'");

			// Mise à jour de la table d'activité
			$wpdb->query("DELETE FROM `wp_bp_activity` WHERE user_id='$userid' AND item_id='" . $gid . "' AND component='groups'");
			
			// Mise à jour des méta données du groupe
			$wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=meta_value-1 WHERE group_id='" . $gid . "' AND meta_key='total_member_count'"); 
			$wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=NOW() WHERE group_id='" . $gid. "' AND meta_key='last_activity'"); 
			
			// Mise à jour des méta données utilisateur
			$wpdb->query("UPDATE wp_usermeta SET meta_value=meta_value-1 WHERE user_id='" . $userid ."' AND meta_key='total_group_count'");
			$wpdb->query("UPDATE wp_usermeta SET meta_value=NOW() WHERE user_id='$userid' AND meta_key='last_activity'"); 
		}				
	}

	// Détachement d'un utilisateur de l'ensemble des groupes BUDDY
	function detacheUserAllBuddy($id,$userid) {
		global $wpdb;
		
		$groups = $wpdb->get_results("SELECT * FROM ".$blog_tb."wp_bp_groups");
		foreach($groups as $group) {
			detacheUserBuddy($id,$group->id,$userid);
		}
	}

//==MAIN BLOCK=========================================================================================================================================
	
	$ds = ldap_connect ( $config['LDAPserver'], $config['LDAPport'] );
	if (!$ds) {
		AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
		die();
	}
	$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
    if (!$r) {
		AfficheLigne("Erreur authentification : impossible de se connecter à l'annuaire LDAP");
		die();
    }

	$blog_list = my_get_blog_list( 0, "all");
	asort($blog_list);
	foreach ($blog_list AS $blog) {
		AfficheTitre("SYNCHRONISATION SITE = ".$blog['path']);
		$blogid=$blog['blog_id'];
		
		$db1->query("SELECT * FROM pia_wordpress WHERE id=$blogid");
		if(!$db1->next_record()||!$db1->f("synchro_user"))
		{
			AfficheLigne("Synchronisation désactivée");
		}
		else 
		{

//=== INIT
			// Vérifions que le blog est bien le principal
			$blogPrincipal = ($blogid==-1?true:false);
			$reponse = $wpdb->get_row("SELECT path FROM wp_blogs WHERE blog_id='$blogid'");
			if (count($reponse)==1) if($reponse->path == "/wordpress/") $blogPrincipal = true;
			if ($blogPrincipal) {
				AfficheLigneGras("Ce blog est le principal");
				
				// Détection activation de buddypress : il faut utiliser les 2 méthodes en paralelle (???)
                $buddypressActif = is_plugin_active("buddypress/bp-loader.php");
                
                // Méthode 1 : sur une fresh
                /*
				$reponse = $wpdb->get_row("SELECT meta_value FROM wp_sitemeta WHERE meta_key='active_sitewide_plugins'");
				if (count($reponse)==1) foreach (unserialize($reponse->meta_value) as $key => $value) if ($key == "buddypress/bp-loader.php") $buddypressActif = true;
				
				// Méthode 2 : ensuite
				$reponse = $wpdb->get_row("SELECT option_value FROM wp_options WHERE option_name='active_plugins'");
				if (count($reponse)==1) foreach (unserialize($reponse->option_value) as $key => $value) if ($key == "buddypress/bp-loader.php") $buddypressActif = true;
                */
                
				if ($buddypressActif) AfficheLigneGras("Buddypress : activé");
				else  AfficheLigneGras("Buddypress : désactivé");
			}

//=== GENERATION USER			
			// Mise à jour des roles contributeur
			if($db1->f("ldap_abonne")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Abonné");
				
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_abonne"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
                    if(ldap_get_values($ds,$entryID,'memberUid'))
                        GenerateUserByMember($blogid,$ds,ldap_get_values($ds,$entryID,'memberUid'),"subscriber",$db1->f("role_notchange"));
                    else                       
                        GenerateUser($blogid,$ds,$entryID,"subscriber",$db1->f("role_notchange"));	
				}
			}
			
			// Mise à jour des roles contributeur
			if($db1->f("ldap_contributeur")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Contributeur");
				
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_contributeur"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
                    if(ldap_get_values($ds,$entryID,'memberUid'))
                        GenerateUserByMember($blogid,$ds,ldap_get_values($ds,$entryID,'memberUid'),"contributor",$db1->f("role_notchange"));
                    else                    
                        GenerateUser($blogid,$ds,$entryID,"contributor",$db1->f("role_notchange"));	
				}
			}
			
			// Mise à jour des roles auteur
			if($db1->f("ldap_auteur")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Auteur");
				
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_auteur"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
                    if(ldap_get_values($ds,$entryID,'memberUid'))
                        GenerateUserByMember($blogid,$ds,ldap_get_values($ds,$entryID,'memberUid'),"author",$db1->f("role_notchange"));
                    else
                        GenerateUser($blogid,$ds,$entryID,"author",$db1->f("role_notchange"));	
				}
			}
			
			// Mise à jour des roles editeur
			if($db1->f("ldap_editeur")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Editeur");
						
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_editeur"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
                    if(ldap_get_values($ds,$entryID,'memberUid'))
                        GenerateUserByMember($blogid,$ds,ldap_get_values($ds,$entryID,'memberUid'),"editor",$db1->f("role_notchange"));
                    else
                        GenerateUser($blogid,$ds,$entryID,"editor",$db1->f("role_notchange"));	
				}
			}
			
			// Mise à jour des roles administrateur
			if($db1->f("ldap_administrateur")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Administrateur");
						
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_administrateur"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
                    if(ldap_get_values($ds,$entryID,'memberUid'))
                        GenerateUserByMember($blogid,$ds,ldap_get_values($ds,$entryID,'memberUid'),"administrator",1);
                    else                   
                        GenerateUser($blogid,$ds,$entryID,"administrator",1);	
				}
				
				if(isset($config['uid_addadmin'])) {
    				$res = ldap_search($ds,$config['LDAPracine'],"(uid=".$config['uid_addadmin'].")");
				    for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				    {
					    GenerateUser($blogid,$ds,$entryID,"administrator",1);	
				    }
				}
			}

//=== SENTRY			
			// Génération des groupes
			AfficheLigne("");
			AfficheLigneGras("Génération des groupes WP-SENTRY");
			$db2->query("SELECT * FROM pia_wordpress_group WHERE id=$blogid");
			while($db2->next_record()) {
				AfficheLigne("Groupes = ".$db2->f("name_group"));
				$res = ldap_search($ds,$config['LDAPracine'],$db2->f("ldap_query"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid = ldap_get_values($ds,$entryID,'uid');
					$user=get_userdatabylogin($uid[0]);
					if($user->ID>0) {
						AfficheContinue(" ".$uid[0]);
						AtacheUserSentry($blogid,$db2->f("name_group"),$user->ID);
					}
				}
				AfficheLigne("");				
			}
			
			// Purge des groupe obsolète
			AfficheLigne("");
			AfficheLigneGras("Suppression des groupes WP-SENTRY");
			$groups=ListeGroupSentry($blogid);
			foreach($groups as $group) {
				$blog_tb="wp_";
				if($blogid > 1) $blog_tb="wp_".$blogid."_";					

				$db2->query("SELECT * FROM pia_wordpress_group WHERE name_group='".addslashes($group->name)."'");
				if(!$db2->next_record()) {
					AfficheLigne("Groupe = ".$group->name." > supprimé");
					$sql="DELETE FROM ".$blog_tb."sentry_groups WHERE id=".$group->id;
					$wpdb->query($sql);
				}
				else {
					AfficheLigne("Groupe = ".$group->name." > existe toujours");
				}
			}	 			

//=== BUDDY			
			if($blogPrincipal&&$buddypressActif) {
				// Création des groupe BUDDYPRESS uniquement sur le blog principale
				AfficheLigne("");
				AfficheLigneGras("Création des groupes BUDDYPRESS");
				$tbbuddygroup=array();
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_buddygroup"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$cn = ldap_get_values($ds,$entryID,'cn');
					$memberuid=ldap_get_values($ds,$entryID,$db1->f("ldap_buddymemberuid"));
					AfficheLigne("");
					AfficheLigne($cn[0]);

					// Création du groupe BUDDYPRESS
					$idbuddy=createGroupeBuddy($blogid,$cn[0]);
					array_push($tbbuddygroup,$idbuddy);

					foreach($memberuid as $uid) {
						attacheUserBuddy($blogid,$idbuddy,$cn["0"],$uid);
					}

					// Affecter Admin et 2Admin
					array_push($memberuid,"admin");					
					if ($idadmin2!="") {
						array_push($memberuid,$config['uid_addadmin']);					
					}

					// Détacher les personnes obsolète au groupe Buddy
					$memberBuddy=memberBuddy($blogid,$idbuddy);
					foreach($memberBuddy as $member) {
						if ($user=get_userdata($member)) {
							$user_login=$user->user_login;
							if(!in_array($user_login,array_map("strtolower",$memberuid))) {
								AfficheLigne("Détachement Utilisateur = ".$user_login);
								detacheUserBuddy($blogid,$idbuddy,$member);
							}
						}
					}					
				}
			}


//=== PURGE BUDDYPRESS
			if($blogPrincipal&&$buddypressActif) {
				AfficheLigne("");
				AfficheLigneGras("Suppression des groupes BUDDY");
				$tbBuddy=listGroupeBuddy($blogid);
				foreach($tbBuddy as $buddy) {
					if(!in_array($buddy,$tbbuddygroup)) {
						deleteGroupeBuddy($blogid,$buddy);
					}
				}
			}

			
			// Suppression
			if($db1->f("del_user")==1) {
			    $fgpurgefin=true;
				AfficheLigne("");
				AfficheLigneGras("Suppression des utilisateurs");				
				DetacheUserBlog($blogid,$ds,"(&".$db1->f("ldap_user")."(|".$db1->f("ldap_abonne").$db1->f("ldap_contributeur").$db1->f("ldap_auteur").$db1->f("ldap_editeur").$db1->f("ldap_administrateur")."))");
				
				AfficheLigne("");
				AfficheLigneGras("Détacher les utilisateurs des groupes");
				foreach($groups as $group) {
					$db2->query("SELECT * FROM pia_wordpress_group WHERE id=$blogid AND name_group='".addslashes($group->name)."'");
					if($db2->next_record()) {
						$ldapsearch="(&".$db1->f("ldap_user").$db2->f("ldap_query").")";
						
						if ($group->member_list!="") $group_members = explode(',', $group->member_list); 
						else $group_members = array();
			  
						foreach($group_members as $member) {
							// Récuperer le login du membre
							$user_info = get_userdata($member);
							AfficheContinue($user_info->user_login);
							$res = ldap_search($ds,$config['LDAPracine'],str_replace("#login#",$user_info->user_login,$ldapsearch));
							if($entryID=ldap_first_entry($ds,$res))	{
								AfficheLigne(" = toujours lié au groupe");
							}
							else {
								AfficheLigne(" = détaché au groupe");
								DetacheUserSentry($blogid,$member);
							}
						}
					}
				}					
			}
		}
		
		AfficheLigne("");
		AfficheLigne("");
		AfficheLigne("");
	}

    // Suppression des utilisateurs sans blog
    if($fgpurgefin) {
	    AfficheTitre("PURGE UTILISATEUR RESEAU");
        $tbusers = $wpdb->get_results("SELECT ID FROM wp_users");
	    foreach($tbusers as $users) {
	        foreach( (array) $users as $user) {
	            foreach((array) $user as $value) {
	                if(count(get_blogs_of_user($value))==0) {
                        $deluser = get_user_by( 'ID', $value );
                        AfficheLigne("Utilisateur = ".$deluser->user_login." > supprimé");
                        wp_delete_user($value,$admin_id);
					    $wpdb->query("DELETE FROM $wpdb->users WHERE ID = $value");
					    $wpdb->query("DELETE FROM $wpdb->usermeta WHERE user_id = $value");                    
           	        }
                }
            }
        }	
    }
    	
    // Ajouter la metadata wpDirAuthFlag à l'ensemble des utilisateurs afin qu'il soit authentifié via le ldap
    $tbusers = $wpdb->get_results("SELECT ID FROM wp_users");
    foreach($tbusers as $users) {
        foreach( (array) $users as $user) {
            foreach((array) $user as $value) {
                $tbmeta=$wpdb->get_results("SELECT * FROM wp_usermeta WHERE user_id=$value AND meta_key='wpDirAuthFlag'");
                if(count($tbmeta)==0) {
                    $wpdb->query("INSERT INTO wp_usermeta (user_id,meta_key,meta_value) VALUES($value,'wpDirAuthFlag','true')");
                }
            }
        }
    }
	
?>
