var nom_classe = '';
var code_classe = '';
var id_classe = '';
var row = '';
var elem = '';
var controls = '<div><button class="input-rounded-button btn-danger">Annuler</button>&nbsp;';
controls += '<button class="input-rounded-button btn-primary btn-associate">Valider</button></div>';
controls += '<span class="error"></span>';

// Associer une classe
$('a.associate').click(function(){
	id_classe = $(this).parent().parent().attr('data-id');
	nom_classe = $(this).parent().parent().attr('data-nom_classe');

	$('input#nom_classe').val(nom_classe);
	$('input#id_classe').val(id_classe);

	row = getRow(this);

	$.ajax({
		type: "GET",
		url: '/posh-profil/synchro/cdt-synchro/associate/'+nom_classe+'/'+id_classe,
		success: function(data) {
			$('#dialog').empty().append(data + controls);

			modal('Associer une classe de l\'annuaire', 'btn-associate');
			$('#dialog div').css('line-height', 'normal');

			select2();
		}
	});

	return false;
});


// Éditer une classe
$('#dialog').on('click', '.btn-associate', function() {
	if(validForm()){
		code_classe = $('#classesLdap').val();
		id_classe = $('#id_classe').val();

		$.ajax({
			type: "POST",
			dataType: "json",
			url: '/posh-profil/synchro/cdt-synchro/associate/'+code_classe+'/'+id_classe,
			data: {'code_classe': code_classe, 'id_classe': id_classe},
			success: function(data) {
				$('#dialog span.error').empty().text(data.msg);		
				
				if(data.success === 'true'){
					// on met à jour la valeur de la colonne code classe dans le tableau
					row.children('.code_classe').text($('#classesLdap').val()).removeClass('error');
					$('#dialog').dialog('close');
				}
			}
		});
	}
});


//Supprimer une classe
$('a.delete').click(function() {
	id_classe = $(this).parent().parent().attr('data-id');
	nom_classe = $(this).parent().parent().attr('data-nom_classe');
	
	$('#dialog').empty().append(controls);
	modal('Supprimer la classe ' + nom_classe + ' ?', 'btn-delete');

	row = getRow(this).attr('data-id');

	return false;
});
$('#dialog').on('click', '.btn-delete', function() {
	$.post('/posh-profil/synchro/cdt-synchro/delete/'+id_classe, function(data, textStatus, xhr) {
		$('#dialog').dialog('close');
	});
	$('tr[data-id="'+row+'"]').remove();

	return false;
});


// Dissocier une classe
$('a.dissociate').click(function() {
	id_classe = $(this).parent().parent().attr('data-id');
	nom_classe = $(this).parent().parent().attr('data-nom_classe');

	$('#dialog').empty().append(controls);
	modal('Dissocier la classe ' + nom_classe + ' ?', 'btn-dissociate');

	row = getRow(this).attr('data-id');

	return false;
});
$('#dialog').on('click', '.btn-dissociate', function() {
	$.post('/posh-profil/synchro/cdt-synchro/dissociate/'+id_classe, function(data, textStatus, xhr) {
		$('#dialog').dialog('close');
	});

	$('tr[data-id="'+row+'"]').children('.code_classe').text('sans correspondance').addClass('error');

	return false;
});


// fermer le modal
$('#dialog').on('click', '.btn-danger', function() {
	$('#dialog').dialog('close');
});

$('#vlsynClass').click(function() {
	$('#dialog').remove();
});