<?php require_once 'header.php'; ?>

<section id="cdt">
	<?php if(!empty($classesCdt['ID_classe']) && isset($classesCdt['ID_classe'])): ?>
	<table cellspacing="20" border="">
		<tr>
			<th colspan="5">Classes du CDT</th>
		</tr>
		<tr class="header">
			<th>Nom classe</th>
			<th>Code classe</th>
			<th colspan="3">Action</th>
		</tr>

		<?php for ($i=0; $i<count($classesCdt['ID_classe']); $i++): ?>
			<?php 
				$code_classe = (!empty($classesCdt['code_classe'][$i]) && (isset($classesCdt['code_classe'][$i]))) ? $classesCdt['code_classe'][$i] : '<span class="error">sans correspondance</span>';
			 ?>
			<tr data-id="<?php echo $classesCdt['ID_classe'][$i]; ?>" data-nom_classe="<?php echo $classesCdt['nom_classe'][$i]; ?>">
				<td class="nom_classe"><?php echo $classesCdt['nom_classe'][$i]; ?></td>
				<td class="code_classe"><?php echo $code_classe; ?></td>
				<td>
					<a class="associate btn-link" href="#">Associer</a>
				</td>
				<td class="delete"><a class="dissociate btn-link" href="#">Dissocier</a></td>
				<td class="delete"><a class="delete btn-link" href="#">Supprimer</a></td>
			</tr>
		<?php endfor; ?>
	</table>
<?php else: ?>
	<strong>
		CDT ne contient aucune classe. <br><br>
		Veuillez utiliser "Synchroniser les classes" pour ajouter les classes de l'annuaire.
	</strong>
<?php endif; ?>

<!-- les classes du ldap -->
<div id="dialog"></div>

<!-- ces champs vont contenir le nom de l'id de la classe en cours d'association -->
<input type="hidden" name="nom_classe" id="nom_classe">
<input type="hidden" name="id_classe" id="id_classe">
</section>

<?php require_once 'footer.php'; ?>
