<?
error_reporting(E_ALL & ~E_NOTICE);
$PATH="../";	
include_once($PATH."include/envole.php");
include_once($PATH."include/dbconf.php");
include_once($PATH."include/mysql.php");
include_once($PATH."include/synchronisation.php");
include_once("/var/www/html/gepi/secure/connect.inc.php");

$db1=new ps_db;
$db1->dbname($config["dbhost"],"gepi",$dbPass,"gepi");

$db2=new ps_db;
$db2->dbname($config["dbhost"],"gepi",$dbPass,"gepi");


// On vérifie si le php est executé en ligne de commande
if(!is_null($argv)) {
	$_SESSION['user_login']="UserCron";
	set_time_limit(600000);
}

function search_array($array, $key, $value)
{
    $results = array();

    if (is_array($array)) {
        if (isset($array[$key]) && $array[$key] == $value) {
            $results[] = $array;
        }

        foreach ($array as $subarray) {
            $results = array_merge($results, search_array($subarray, $key, $value));
        }
    }

    return $results;
}

AfficheTitre("FORCER L'AUTHENTIFICATION SSO POUR L'ENSEMBLE DES UTILISATEURS");
$db1->query("UPDATE utilisateurs SET auth_mode='sso'");

AfficheTitre("SUPPRESSION DES CORRESPONDANCES OBSOLETES");
$db1->query("SELECT * FROM sso_table_correspondance");
while($db1->next_record()) {
	$find=findUsersLDAP("uid",$db1->f("login_sso"));
	if(count($find)==0) {
		AfficheLigne("   - CORRESPONDANCE OBSOLETE = ".$db1->f("login_gepi")." / ".$db1->f("login_sso"));
		$db2->query("DELETE FROM sso_table_correspondance WHERE login_gepi='".$db1->f("login_gepi")."' AND login_sso='".$db1->f("login_sso")."'");
	}

	$db2->query("SELECT * FROM utilisateurs WHERE utilisateurs.login='".$db1->f("login_gepi")."' AND etat='actif'");
	if(!$db2->next_record()) {
		AfficheLigne("   - CORRESPONDANCE OBSOLETE = ".$db1->f("login_gepi")." / ".$db1->f("login_sso"));
		$db2->query("DELETE FROM sso_table_correspondance WHERE login_gepi='".$db1->f("login_gepi")."' AND login_sso='".$db1->f("login_sso")."'");
	}
}


AfficheTitre("LISTE DES ELEVES GEPI");
$eleves=listeUtilisateurs("Base","eleve");
$db1->query("SELECT * FROM utilisateurs, eleves WHERE utilisateurs.statut='eleve' AND utilisateurs.etat='actif' AND utilisateurs.login=eleves.login");
while($db1->next_record()) {
	// On regarde si l'utilisateur est déjà associé à un compte annuaire
	$db2->query("SELECT * FROM sso_table_correspondance WHERE login_gepi='".$db1->f("login")."'");
	$fgtoattach=false;
	if(!$db2->next_record()) $fgtoattach=true;
	elseif($db2->f("login_sso")=="") $fgtoattach=true;

	if($db1->f("no_gep")=="") {
		AfficheLigneKO("   - LOGIN GEPI = ".$db1->f("login")." SANS INE");
	}
	else {
		if(!$fgtoattach) 
			AfficheLigneRAS("   - LOGIN GEPI = ".$db1->f("login")." - INE = ".$db1->f("no_gep")." déjà rattaché au login annuaire = ".$db2->f("login_sso"));
		else {
			// On recherche la correspondance de l'élève gepi via l'ine
			$find=search_array($eleves,"ine",$db1->f("no_gep"));
			if(count($find)==0) 
				AfficheLigneKO("   - LOGIN GEPI = ".$db1->f("login")." - INE = ".$db1->f("no_gep")." AUCUNE CORRESPONDANCE");	
			elseif(count($find)>1)
				AfficheLigneKO("   - LOGIN GEPI = ".$db1->f("login")." - INE = ".$db1->f("no_gep")." PLUSIEURS CORRESPONDANCES TROUVEES");	
			else {
				AfficheLigneOK("   - LOGIN GEPI = ".$db1->f("login")." - INE = ".$db1->f("no_gep")." rattachement au login annuaire ".$find[0]["uid"]);
				$db2->query("INSERT INTO sso_table_correspondance (login_gepi,login_sso) VALUES ('".$db1->f("login")."','".$find[0]["uid"]."')");
			}
		}
	}
}

AfficheTitre("LISTE DES RESPONSABLES GEPI");
$responsables=listeUtilisateurs("Base","responsable");
$ineresp=array();
foreach($responsables as $responsable) {
	$ineresp[$responsable["uid"]]=array();
	foreach($responsable["enfants"] as $enfant) {
		if($enfant["ine"]!="")
			array_push($ineresp[$responsable["uid"]],array("ine"=>$enfant["ine"],"uid"=>$responsable["uid"],"idprenomnom"=>$responsable["idprenomnom"]));
	}
}

$db1->query("SELECT * FROM utilisateurs, resp_pers WHERE utilisateurs.statut='responsable' AND utilisateurs.etat='actif' AND utilisateurs.login=resp_pers.login");
while($db1->next_record()) {
	// On regarde si l'utilisateur est déjà associé à un compte annuaire
	$db2->query("SELECT * FROM sso_table_correspondance WHERE login_gepi='".$db1->f("login")."'");
	$fgtoattach=false;
	if(!$db2->next_record()) $fgtoattach=true;
	elseif($db2->f("login_sso")=="") $fgtoattach=true;

	if(!$fgtoattach)
		AfficheLigneRAS("   - LOGIN GEPI = ".$db1->f("login")." - PERS_ID = ".$db1->f("pers_id")." déjà rattaché au login annuaire = ".$db2->f("login_sso"));
	else {	
		// Pour chaque enfants du responsable
		$db2->query("SELECT * FROM responsables2, eleves WHERE responsables2.pers_id='".$db1->f("pers_id")."' AND responsables2.ele_id=eleves.ele_id");
		$fgfindattach=false;
		while($db2->next_record()) {
			// Recherche de son enfant dans l'annuaire via l'ine
			if($db2->f("no_gep")!="") {
				$find=search_array($ineresp,"ine",$db2->f("no_gep"));
				if(count($find)==1) {
					$fgfindattach=true;
					AfficheLigneOK("   - LOGIN GEPI = ".$db1->f("login")." - PERS_ID = ".$db1->f("pers_id")." rattachement au login annuaire ".$find[0]["uid"]);
					$db2->query("INSERT INTO sso_table_correspondance (login_gepi,login_sso) VALUES ('".$db1->f("login")."','".$find[0]["uid"]."')");
					break;
				}
				elseif(count($find)>1) {

					// Plusieurs parents pour l'enfant on recherche dans les parents de l'enfant trouvé celui qui se rapproche via prenomnom
					$find2=search_array($find,"idprenomnom",strtolower(replaceAccent($db1->f("prenom").$db1->f("nom"))));
					if(count($find2)==1) {
						$fgfindattach=true;
						AfficheLigneOK("   - LOGIN GEPI = ".$db1->f("login")." - PERS_ID = ".$db1->f("pers_id")." rattachement au login annuaire ".$find2[0]["uid"]);
						$db2->query("INSERT INTO sso_table_correspondance (login_gepi,login_sso) VALUES ('".$db1->f("login")."','".$find2[0]["uid"]."')");
						break;
					}
				}
			}
		}

		if(!$fgfindattach) {
			AfficheLigneKO("   - LOGIN GEPI = ".$db1->f("login")." - PERS_ID = ".$db1->f("pers_id")." rapprochement non trouvé");
		}
	}
}

AfficheTitre("LISTE DES PERSONNELS GEPI");
$personnels=array_merge(listeUtilisateurs("Base","enseignant"),listeUtilisateurs("Base","administratif"));
$db1->query("SELECT * FROM utilisateurs WHERE (utilisateurs.statut='professeur' OR utilisateurs.statut='scolarite' OR utilisateurs.statut='secours' OR utilisateurs.statut='cpe') AND utilisateurs.etat='actif' ");
while($db1->next_record()) {
	// On regarde si l'utilisateur est déjà associé à un compte annuaire
	$db2->query("SELECT * FROM sso_table_correspondance WHERE login_gepi='".$db1->f("login")."'");
	$fgtoattach=false;
	if(!$db2->next_record()) $fgtoattach=true;
	elseif($db2->f("login_sso")=="") $fgtoattach=true;

	if(!$fgtoattach)
		AfficheLigneRAS("   - LOGIN GEPI = ".$db1->f("login")." déjà rattaché au login annuaire = ".$db2->f("login_sso"));
	else {	
		$find=search_array($personnels,"idprenomnom",strtolower(replaceAccent($db1->f("prenom").$db1->f("nom"))));
		if(count($find)==1) {
			AfficheLigneOK("   - LOGIN GEPI = ".$db1->f("login")." rattachement au login annuaire ".$find[0]["uid"]);
			$db2->query("INSERT INTO sso_table_correspondance (login_gepi,login_sso) VALUES ('".$db1->f("login")."','".$find[0]["uid"]."')");			
		}
		else 
			AfficheLigneKO("   - LOGIN GEPI = ".$db1->f("login")." rapprochement non trouvé");
	}
}

AfficheTitre("RATTACHEMENT DU COMPTE ADMIN");
$db2->query("INSERT INTO sso_table_correspondance (login_gepi,login_sso) VALUES ('admin','admin')  ON DUPLICATE KEY UPDATE login_sso='admin'");		
if($config["uid_addadmin"]!="") $db2->query("INSERT INTO sso_table_correspondance (login_gepi,login_sso) VALUES ('".$config["uid_addadmin"]."','".$config["uid_addadmin"]."')  ON DUPLICATE KEY UPDATE login_sso='".$config["uid_addadmin"]."'");	

AfficheLigne("");
AfficheLigne("");
AfficheLigne("");
	
